function test_MIMO()
    close all;clc;
    
    fprintf('Test MIMO Problem\n');
    
    T = input('Input time period: ');
    if(isempty(T))
        T = 0.002;
        fprintf('Default: T = %1.2d\n\n', T);
    end
    if(T <= 0)
        fprintf('Exit!\n\n');
        return;
    end
    
    W = input('Input frequency: ');
    if(isempty(W))
        W = 30000;
        fprintf('Default: W = %d\n\n', W);
    end
    if(W <= 0)
        fprintf('Exit!\n\n');
        return;
    end
    
    ns = input('Input number of signals: ');
    if(isempty(ns))
        ns = 2;
        fprintf('Default: ns = %d\n\n', ns);
    end
    if(ns < 2)
        fprintf('Exit!\n\n');
        return;
    end
    
    
    delta = []; % Assuming no more than 4 values
    cnt = 1;
    while(cnt < 5)
        tmp = input('Input positive integer delta_n: ');
        if(isempty(tmp))
            break;
        end
        
        if(tmp <= 0)
            fprintf('Delta_n must be positive!\n\n');
            return;
        end
        
        if(tmp == delta(1 : (cnt-1)))
            fprintf('You have already selected that delta_n value!\n\n');
        else
            delta(cnt) = tmp;
        
            anotherVal = input('Input another value? (1) Yes, (2) No: ');
            if(isempty(anotherVal) || anotherVal == 2)
                break;
            end

            cnt = cnt + 1;
        end
    end
    if(isempty(delta))
        delta = [2 4 6];
        fprintf('Default: delta_n = ');
        for i = 1 : length(delta)
            fprintf(' %d, ', delta(i));
        end
        fprintf('\n\n');
    else
        fprintf('Testing delta_n value(s): ')
        for i = 1 : length(delta)
            fprintf('%d, ', delta(i));
        end
        fprintf('\n\n');
    end
    
    fprintf('Which oblique manifold retraction/vector transport combination:\n');
    fprintf('1, Retraction: qf, Vector Transport: parallelization\n');
    fprintf('2, Retraction: exponential mapping, Vector Transport: parallel translation (locking condition)\n');
    fprintf('3, Retraction: qf, Vector Transport: parallel translation\n');
    fprintf('4, Retraction: qf, Vector Transport: parallel translation (locking condition)\n');
    maniSet = input('please input: ');
    if(isempty(maniSet))
        maniSet = 3;
        fprintf('Default: %d, Retraction: qf, Vector Transport: parallel translation\n\n', maniSet);
    end
    if(maniSet < 1 || maniSet > 4)
        fprintf('Exit!\n\n');
        return;
    end
    
    fprintf('Which Riemannian Optimization Method(s):\n');
    fprintf('1, RBFGS\n');
    fprintf('2, LRBFGS:2\n');
    fprintf('3, LRBFGS:4\n');
    fprintf('4, LRBFGS:8\n');
    fprintf('5, RSD\n');
    fprintf('6, RNewton\n');
    alg = []; % Assuming no more than all 6 algorithms
    cnt = 1;
    while(cnt < 7)
        tmp = input('please input: ');
        if(isempty(tmp))
            break
        end
        
        if(tmp < 1 || tmp > 6)
            fprintf('Exit!\n\n');
            return;
        end
        
        if(tmp == alg(1 : (cnt-1)))
            fprintf('You have already selected that algorithm!\n\n');
        else
            alg(cnt) = tmp;
            
            anotherVal = input('Input another algorithm? (1) Yes, (2) No: ');
            if(isempty(anotherVal) || anotherVal == 2)
                break;
            end

            cnt = cnt + 1;
        end
    end
    if(isempty(alg))
        alg = 5;
        fprintf('Default: RSD\n\n');
    else
        fprintf('Running algorithms: ')
        for i = 1 : length(alg)
            if(alg(i) == 1)
                fprintf('RBFGS, ');
            elseif(alg(i) == 2)
                fprintf('LRBFGS:2, ');
            elseif(alg(i) == 3)
                fprintf('LRBFGS:4, ');
            elseif(alg(i) == 4)
                fprintf('LRBFGS:8, ');
            elseif(alg(i) == 5)
                fprintf('RSD, ');
            elseif(alg(i) == 6)
                fprintf('RNewton, ');
            end
        end
        fprintf('\n\n');
    end
    
    isplotsignals = input('Plot Signals (1) Yes, (2) No:  ');
    if(isempty(isplotsignals))
        isplotsignals = 1;
        fprintf('Default: Yes\n\n');
    end
    if(isplotsignals < 1 || isplotsignals > 2)
        fprintf('Exit!\n\n');
        return;
    end
    
    isplotalgs = input('Plot Algorithm Comparison (1) Yes, (2) No:  ');
    if(isempty(isplotalgs))
        isplotalgs = 2;
        fprintf('Default: No\n\n');
    end
    if(isplotalgs < 1 || isplotalgs > 2)
        fprintf('Exit!\n\n');
        return;
    end

    driver_MIMO_SPIE(T, W, ns, maniSet, alg, delta, isplotsignals, isplotalgs);
end